From 200c2fba85b2e6820b9f93c3b4a49eb1e3c863e5 Mon Sep 17 00:00:00 2001
From: Robert Andrew Rankin <andrew@eiknet.com>
Date: Tue, 1 Mar 2011 19:04:24 -0500
Subject: [PATCH] Trac Ticket #509: A fix that does not break everything else. (https://fedorahosted.org/cobbler/ticket/509)

---
 cobbler/remote.py |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

diff --git a/cobbler/remote.py b/cobbler/remote.py
index d7c9861..55c8056 100644
--- a/cobbler/remote.py
+++ b/cobbler/remote.py
@@ -92,7 +92,7 @@ class CobblerThread(Thread):
         try:
             rc = self._run(self)
             self.remote._set_task_state(self,self.event_id,EVENT_COMPLETE)
-            self.on_done(self)
+            self.on_done()
             return rc
         except:
             utils.log_exc(self.logger)
@@ -328,9 +328,11 @@ class CobblerXMLRPCInterface:
         logatron = clogger.Logger("/var/log/cobbler/tasks/%s.log" % event_id)
 
         thr_obj = CobblerThread(event_id,self,logatron,args)
+        on_done_type = type(thr_obj.on_done)
+
         thr_obj._run = thr_obj_fn
         if on_done is not None:
-           thr_obj.on_done = on_done
+           thr_obj.on_done = on_done_type(on_done, thr_obj, CobblerThread)
         thr_obj.start()
         return event_id
 
-- 
1.5.5.6

